<?php

/*
 * @version $Id: addons.php 234 2013-12-17 22:30:03Z hi $
 *
 */

/*
 * @Version: 1.6.1@
 * @Date: 2013-12-16@
 * 
 * Liest alle Galerie-Ordner in denen min. 1 Thumbnail enthalten ist.
 * Return: mehrdimensionales Array => $path = relativer Pfad => array($thumbs mit relativem Pfad zu allen Thumbs)
 * (Galeriename kann mit basename($path) generiert werden)
 */

function lb_links($folders = NULL) {
    global $pth, $plugin_cf;

    include_once $pth['folder']['plugins'] . 'gallery/includes/thumbcreate.php';

    $lbg_CMSfolder = 'images';
    if (preg_match("/userfiles/i", $plugin_cf['gallery']['gallery-base-folder'])) {
        $lbg_CMSfolder = 'userfiles';
    }
    $lbg_Galleryfolder = $plugin_cf['gallery']['gallery-folder'];
    if (substr($lbg_Galleryfolder, -1, 1) <> '/') {
        $lbg_Galleryfolder .= '/';
    }
    $lbgMainFolder = $pth['folder'][$lbg_CMSfolder] . $lbg_Galleryfolder;

    $gallery_paths = array();
    if (!$folders || $folders == '*') {
        //alle Ordner suchen
        $handle = opendir($lbgMainFolder);
        if ($handle) {
            while ($lbgFolder = readdir($handle)) {
                if (strpos($lbgFolder, '.') === false
                        && is_dir($lbgMainFolder . $lbgFolder)
                        && file_exists($lbgMainFolder . $lbgFolder . '/thumb')) {
                    //array_push($gallery_paths, $lbgMainFolder . $lbgFolder . '/thumb/');
                    array_push($gallery_paths, $lbgMainFolder . $lbgFolder . '/');
                }
            }
            closedir($handle);
        }
        natsort($gallery_paths);
    } else {
        //nur uebergebene Galerienamen, nicht sortieren!
        $galleries = explode(',', $folders);
        foreach ($galleries as $lbgFolder) {
            $lbgFolder = trim($lbgFolder);
            if (is_dir($lbgMainFolder . $lbgFolder)
                    && file_exists($lbgMainFolder . $lbgFolder . '/thumb')) {
                array_push($gallery_paths, $lbgMainFolder . $lbgFolder . '/');
            }
        }
    }
    //thumbs lesen
    $gallery_links = array();
    foreach ($gallery_paths as $path) {
        $thumbs = array();
        $images = ReadImagesList($path);
        foreach ($images as $thumb) {
            $thumb = $path . 'thumb/tn_' . $thumb;
            if (file_exists($thumb)) {
                array_push($thumbs, $thumb);
            }
        }
        if (count($thumbs) > 0) {
            array_push($gallery_links, array($path, $thumbs));
//            var_dump($gallery_links);
        }
    }
    if (count($gallery_links) > 0) {
        return $gallery_links;
    } else {
        return FALSE;
    }
}

/*
 * Erzeugt eine Uebersicht mit Links zu allen gefundenen Galerien
 * $random TRUE verlinkt ein zufaelliges Thumbnail, ansonsten das
 * erste Bild in der Liste
 */

function lb_gallery_all($random = FALSE, $layout = 'div') {
    global $o, $plugin_tx, $pth, $sn, $su, $lb_gallery_version;

    if (!isset($_SESSION)) {
        session_start();
    }

    include_once $pth['folder']['plugins'] . 'gallery/includes/thumbcreate.php';

    $lb_action = isset($_GET['lb_action']) ? preg_replace('/[^a-zA-Z0-9_]/', '', $_GET['lb_action']) : '';
    $lb_name = isset($_GET['lb_name']) ? preg_replace('/[^a-zA-Z0-9_]/', '', $_GET['lb_name']) : '';
    $html = '';
    $desc = '';

    $links = lb_links();
    if (count($links) < 1) {
//        i18n
        $o .= 'No galleries found';
        return $o;
    }

    if ($lb_action == '') {
        switch ($layout) {
            case 'table' :
                $html = '<div id="lb_overview"><div id="lb_overview_inner">' . "\n"
                        . '<table class="lb_galleries">' . "\n";
                foreach ($links as $val) {
                    if (!file_exists($val[0] . '.ignore')) {
                        $desc = file_get_contents($val[0] . filename_for_desc());
                        $gallery = basename($val[0]);
                        if (preg_match('~<h1>(.+?)</h1>~is', $desc, $matches)) {
                            $_SESSION['lbg_title'][$gallery] = $matches[1];
                        } else {
                            $_SESSION['lbg_title'][$gallery] = '';
                        }
                        if (!$random) {
                            $thumb = $val[1][0];
                        } else {
                            $i = rand(0, (count($val[1]) - 1));
                            $thumb = $val[1][$i];
                        }
                        $link = '<a class="thumb" href="' . $sn . '?' . $su . '&amp;lb_action=view&amp;lb_name=' . $gallery . '">'
                                . tag('img class="picture" src="' . $thumb . '" alt=""') . '</a>';
                        $html .= '<tr>' . "\n";
                        $html .= '<td class="lb_thumb_cell">' . $link . ' </td><td class="lb_desc_cell">' . $desc . '</td>' . "\n";
                        $html .= '</tr>' . "\n";
                    }
                }
                $html .= '</table></div></div>' . "\n";
                break;
//            case 'div' :
            default:
                $html = '<div id="lb_overview"><div id="lb_overview_inner">' . "\n";
                foreach ($links as $val) {
                    if (!file_exists($val[0] . '.ignore')) {
                        $desc = file_get_contents($val[0] . filename_for_desc());
                        $gallery = basename($val[0]);
                        preg_match('~<h1>(.+?)</h1>~is', $desc, $matches);
                        if (preg_match('~<h1>(.+?)</h1>~is', $desc, $matches)) {
                            $_SESSION['lbg_title'][$gallery] = $matches[1];
                        } else {
                            $_SESSION['lbg_title'][$gallery] = '';
                        }
                        if (!$random) {
                            $thumb = $val[1][0];
                        } else {
                            $i = rand(0, (count($val[1]) - 1));
                            $thumb = $val[1][$i];
                        }
                        $link = '<a class="thumb" href="' . $sn . '?' . $su . '&amp;lb_action=view&amp;lb_name=' . $gallery . '">'
                                . tag('img class="picture" src="' . $thumb . '" alt=""') . '</a>';
                        $html .= '<div class="lb_overview_item">' . "\n";
                        $html .= '<div class="lb_overview_thumb">' . $link . ' </div>' . $desc . "\n";
                        $html .= '</div>' . tag('br style="clear: left;"') . "\n";
                    }
                }
                $html .= '</div></div>' . "\n";
                break;
        }
        $html .= "\n" . '<div class="gallery_copy">' . "\n";
        $html .= '<a target="_blank" href="http://cmsimple.holgerirmler.de/">made with lb_Gallery ' . $lb_gallery_version . '</a>';
        $html .= "\n" . '</div>';
        return $html;
    }

    //Galerien aufrufen
    if ($lb_action == 'view' && $lb_name != '') {
        $back = $sn . '?' . $su;
        $t = '<p class="lb_all_backtop"><a class="lb_all_back" href="' . $back . '">'
                . $plugin_tx['gallery']['overview_Backlink'] . '</a></p>';
        if ($_SESSION['lbg_title'][$lb_name] != '') {
            $t .= '<div class="lb_all_title"><h1>' . $_SESSION['lbg_title'][$lb_name] . '</h1></div>';
        }
        $t .= lb_gallery($lb_name);
        $t .= '<p class="lb_all_backbottom"><a class="lb_all_back" href="' . $back . '">'
                . $plugin_tx['gallery']['overview_Backlink'] . '</a></p>';
        return $t;
    }
}

/*
 * Gleiche Funktion wie gallery_all, nur erste Parameter eine mit Komma separierte
 * Liste mit Galerienamen, die in die Übersicht aufgenommen werden
 * $random TRUE verlinkt ein zufaelliges Thumbnail, ansonsten das
 * erste Bild in der Liste
 */

function lb_galleries($foldernames = FALSE, $random = FALSE, $layout = 'div') {
    global $o, $plugin_tx, $pth, $sn, $su, $lb_gallery_version;

    if (!isset($_SESSION)) {
        session_start();
    }

    include_once $pth['folder']['plugins'] . 'gallery/includes/thumbcreate.php';

    $lb_action = isset($_GET['lb_action']) ? preg_replace('/[^a-zA-Z0-9_]/', '', $_GET['lb_action']) : '';
    $lb_name = isset($_GET['lb_name']) ? preg_replace('/[^a-zA-Z0-9_]/', '', $_GET['lb_name']) : '';
    $html = '';
    $desc = '';

    $links = lb_links($foldernames);
    if (count($links) < 1) {
//        i18n
        $o .= 'No galleries found';
        return $o;
    }

    if ($lb_action == '') {
        switch ($layout) {
            case 'table' :
                $html = '<div id="lb_overview"><div id="lb_overview_inner">' . "\n"
                        . '<table class="lb_galleries">' . "\n";
                foreach ($links as $val) {
                    if (!file_exists($val[0] . '.ignore')) {
                        $desc = file_get_contents($val[0] . filename_for_desc());
                        $gallery = basename($val[0]);
                        if (preg_match('~<h1>(.+?)</h1>~is', $desc, $matches)) {
                            $_SESSION['lbg_title'][$gallery] = $matches[1];
                        } else {
                            $_SESSION['lbg_title'][$gallery] = '';
                        }
                        if (!$random) {
                            $thumb = $val[1][0];
                        } else {
                            $i = rand(0, (count($val[1]) - 1));
                            $thumb = $val[1][$i];
                        }
                        $link = '<a class="thumb" href="' . $sn . '?' . $su . '&amp;lb_action=view&amp;lb_name=' . $gallery . '">'
                                . tag('img class="picture" src="' . $thumb . '" alt=""') . '</a>';
                        $html .= '<tr>' . "\n";
                        $html .= '<td class="lb_thumb_cell">' . $link . ' </td><td class="lb_desc_cell">' . $desc . '</td>' . "\n";
                        $html .= '</tr>' . "\n";
                    }
                }
                $html .= '</table></div></div>' . "\n";
                break;
//            case 'div' :
            default:
                $html = '<div id="lb_overview"><div id="lb_overview_inner">' . "\n";
                foreach ($links as $val) {
                    if (!file_exists($val[0] . '.ignore')) {
                        $desc = file_get_contents($val[0] . filename_for_desc());
                        $gallery = basename($val[0]);
                        preg_match('~<h1>(.+?)</h1>~is', $desc, $matches);
                        if (preg_match('~<h1>(.+?)</h1>~is', $desc, $matches)) {
                            $_SESSION['lbg_title'][$gallery] = $matches[1];
                        } else {
                            $_SESSION['lbg_title'][$gallery] = '';
                        }
                        if (!$random) {
                            $thumb = $val[1][0];
                        } else {
                            $i = rand(0, (count($val[1]) - 1));
                            $thumb = $val[1][$i];
                        }
                        $link = '<a class="thumb" href="' . $sn . '?' . $su . '&amp;lb_action=view&amp;lb_name=' . $gallery . '">'
                                . tag('img class="picture" src="' . $thumb . '" alt=""') . '</a>';
                        $html .= '<div class="lb_overview_item">' . "\n";
                        $html .= '<div class="lb_overview_thumb">' . $link . ' </div>' . $desc . "\n";
                        $html .= '</div>' . tag('br style="clear: left;"') . "\n";
                    }
                }
                $html .= '</div></div>' . "\n";
                break;
        }
        $html .= "\n" . '<div class="gallery_copy">' . "\n";
        $html .= '<a target="_blank" href="http://cmsimple.holgerirmler.de/">made with lb_Gallery ' . $lb_gallery_version . '</a>';
        $html .= "\n" . '</div>';
        return $html;
    }

    //Galerien aufrufen
    if ($lb_action == 'view' && $lb_name != '') {
        $back = $sn . '?' . $su;
        $t = '<p class="lb_all_backtop"><a class="lb_all_back" href="' . $back . '">'
                . $plugin_tx['gallery']['overview_Backlink'] . '</a></p>';
        if ($_SESSION['lbg_title'][$lb_name] != '') {
            $t .= '<div class="lb_all_title"><h1>' . $_SESSION['lbg_title'][$lb_name] . '</h1></div>';
        }
        $t .= lb_gallery($lb_name);
        $t .= '<p class="lb_all_backbottom"><a class="lb_all_back" href="' . $back . '">'
                . $plugin_tx['gallery']['overview_Backlink'] . '</a></p>';
        return $t;
    }
}

function lb_sortJS($folder = '') {

    $o = '<script type="text/javascript">';
    $o .= "\n" . 'jQuery(document).ready(function($){
		$(function() {
			$("#gallerySorter ul").sortable({ opacity: 0.6, cursor: \'move\', update: function() {
				var order = $(this).sortable("serialize") + \'&action=UpdateSortedImages\'; 
				$.post("' . $folder . 'update_images_list.php", order, function(theResponse){
				$("#lb_gallery_sort_message").html(theResponse);
				}); 															 
				}								  
			});
		});

            });';
    $o .= '</script>';

    return $o;
}