<?php

/*
 * hi_FancyBox for CMSimple - main module
 *
 * A simple plugin to include FancyBox (http://fancybox.net)
 * and apply it to predefined css-classes
 *
 * @author Holger Irmler
 * @link http://CMSimple.HolgerIrmler.de
 * @version 3.0.1
 * @date: 2012-03-10
 * @build: 2012031001
 * @package hi_fancybox
 */

if ((!function_exists('sv')) || preg_match('#hi_fancybox' . DIRECTORY_SEPARATOR . 'index.php#i', sv('PHP_SELF')))
    die('Access denied');

//settings not ready in older CMSimple-Versions
if (!isset($plugin_cf['hi_fancybox'])) {
    include($pth['folder']['plugins'] . 'hi_fancybox/config/config.php');
}

if ($plugin_cf['hi_fancybox']['activate'] == '1' && !$edit) {

//Read settings for FancyBox from plugin_cf
    $fcbSettings = '';
    while (list( $key, $val ) = each($plugin_cf['hi_fancybox'])) {
        if (substr($key, 0, 4) == 'fcb_' && $val != '') {
            $fcbSettings .= substr($key, 4) . ': ' . $val . ',';
        }
    }
    $fcbSettings = substr($fcbSettings, 0, -1);


    //Write the Script-tags to head section
    //include jQuery-Plugin for CMSimple
    if (!file_exists($pth['folder']['plugins'] . 'jquery/jquery.inc.php')) {
        $o .= '<div class="cmsimplecore_warning">' .
                $plugin_tx['hi_fancybox']['jquery_missing'] .
                '</div>';
        //drop the rest of the plugin-code
        return($o);
    } else {
        //load inculde-file from jQuery-plugin
        include_once($pth['folder']['plugins'] . 'jquery/jquery.inc.php');
        //include jQuery to the <head>
        include_jQuery();
        //and the plugins...
        include_jQueryPlugin('fancybox', $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/jquery.fancybox-1.3.4.pack.js');
        include_jQueryPlugin('easing', $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/jquery.easing-1.3.pack.js');
        include_jQueryPlugin('mousewheel', $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/jquery.mousewheel-3.0.4.pack.js');
        //stylesheet
        $hjs .= "\n" . tag('link rel="stylesheet" type="text/css" media="screen" href="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/jquery.fancybox-1.3.4.css"');
        $hjs .= "\n";

        //fancybox IE-styles, IE needs paths relative from html-document
        $hjs .= "\n" . '<style type="text/css">';
        $hjs .= "\n" . '#fancybox-loading.fancybox-ie div { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_loading.png", sizingMethod="scale");}';
        $hjs .= "\n" . '.fancybox-ie #fancybox-close { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_close.png", sizingMethod="scale");}';
        $hjs .= "\n" . '.fancybox-ie #fancybox-title-over { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_title_over.png", sizingMethod="scale"); zoom: 1; }';
        $hjs .= "\n" . '.fancybox-ie #fancybox-title-left { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_title_left.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancybox-title-main { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_title_main.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancybox-title-right { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_title_right.png", sizingMethod="scale"); }';
        $hjs .= "\n";
        $hjs .= "\n" . '.fancybox-ie #fancybox-left-ico { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_nav_left.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancybox-right-ico { background: transparent; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_nav_right.png", sizingMethod="scale"); }';
        $hjs .= "\n";
        $hjs .= "\n" . '.fancybox-ie .fancy-bg { background: transparent !important; }';
        $hjs .= "\n";
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-n { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_n.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-ne { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_ne.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-e { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_e.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-se { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_se.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-s { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_s.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-sw { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_sw.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-w { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_w.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '.fancybox-ie #fancy-bg-nw { filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_shadow_nw.png", sizingMethod="scale"); }';
        $hjs .= "\n" . '</style>' . "\n";

        //overwrite css to show navigation arrows always
        if ($plugin_cf['hi_fancybox']['nav_always_visible'] == 1) {
            $hjs .= "\n" . tag('link rel="stylesheet" type="text/css" media="screen" href="' . $pth['folder']['base'] . 'plugins/hi_fancybox/libs/fancybox/fancybox-1.3.4/fancy_nav_on.css"');
        }

        //apply fancybox
        $fcbJs = "\n" .
                '<script type="text/javascript">
                    jQuery(document).ready(function(){
                        jQuery("' . $plugin_cf['hi_fancybox']['class_single'] . '").fancybox({' . $fcbSettings . '});
                        jQuery("' . $plugin_cf['hi_fancybox']['class_group'] . '").attr(\'rel\', \'gallery\').fancybox({' . $fcbSettings . '});
                        jQuery("' . $plugin_cf['hi_fancybox']['class_iframe'] . '").fancybox({' . $fcbSettings . ', autoscale: false, type: \'iframe\'});
                        jQuery("#gallery_main a[rel^=\'fancybox\']").fancybox({' . $fcbSettings . ', type: \'image\'});			//for lb_Gallery
                    });
		</script>' . "\n";

        if (!$su) {
            $c[0] .= $fcbJs;
        } else {
            $c[$s] .= $fcbJs;
        }
    }
}
?>